#include "mfciter.h"

typedef MFCArrayIter <CStringArray, CString> Array_Iter;


void main(){


CStringArray array;

array.Add("California");
array.Add("Maryland");
array.Add("Alabama");
array.Add("South Dakota");
array.Add("Oregon");
array.Add("New Mexico");
array.Add("Nevada");
array.Add("Virginia");
array.Add("Maine");
array.Add("Missouri");
array.Add("Connecticut");
array.Add("Kentucky");
array.Add("Ohio");
array.Add("Iowa");
array.Add("South Carolina");
array.Add("Mississippi");
array.Add("Massachusetts");
array.Add("U.S. Virgin Islands");
array.Add("West Virginia");
array.Add("Kansas");
array.Add("North Dakota");
array.Add("Alaska");
array.Add("New York");
array.Add("Arkansas");
array.Add("Michigan");
array.Add("Arizona");
array.Add("Georgia");
array.Add("Pennsylvania");
array.Add("New Jersey");
array.Add("Delaware");
array.Add("Washington,D.C.");
array.Add("North Carolina");
array.Add("Washington (State)");
array.Add("Wyoming");
array.Add("Utah");
array.Add("New Hampshire");
array.Add("New York");
array.Add("Georgia");
array.Add("Hawaii");
array.Add("Florida");
array.Add("Louisiana");
array.Add("New York");
array.Add("Tennessee");
array.Add("Oklahoma");
array.Add("Puerto Rico");
array.Add("Colorado");
array.Add("Minnesota");
array.Add("Montana");
array.Add("Indiana");
array.Add("Texas");
array.Add("Wisconsin");
array.Add("Rhode Island");
array.Add("Nebraska");
array.Add("Vermont");
array.Add("Idaho");
array.Add("Illinois");


    
CStringArray array1;
array1.Add("Florida");
array1.Add("Minnesota");
array1.Add("Texas");
array1.Add("South America");
array1.Add("Europe");
array1.Add("Asia");

//Print unsorted array to stdout
std::cout << "\nUnsorted array\n";
Array_Iter theIterator(&array);
std::copy(theIterator.begin(), theIterator.end(), 
          ostream_iterator <const char*> (cout, "\n"));


//Sort array and eliminate duplicates
cout << "\nSorted array with removed duplicates\n";
std::sort(theIterator.begin(), theIterator.end());
Array_Iter newEnd = std::unique(theIterator.begin(),
    theIterator.end());
array.SetSize(array.GetSize() - (theIterator.end() - newEnd));

//define new iterator for the array without duplicates
Array_Iter theNewIterator(&array);
std::copy(theNewIterator.begin(), theNewIterator.end(), 
          ostream_iterator <const char*> (cout, "\n"));

Array_Iter theIterator1(&array1);
std::sort(theIterator1.begin(), theIterator1.end());
cout << "\nSorted second Array\n";
std::copy(theIterator1.begin(), theIterator1.end(), 
          ostream_iterator <const char*> (cout, "\n"));


//Compute intersection
CStringArray arrayIntersect;
std::set_intersection(theNewIterator.begin(), theNewIterator.end(),
      theIterator1.begin(), theIterator1.end(),
      MFC_back_insert_iterator<CStringArray,
             CString>(arrayIntersect));



//Print intersection to file
Array_Iter theIntersectIterator(&arrayIntersect);
ofstream out("test_debug.txt", ios::out);
out << "Common elements found in both arrays:\n";
std::copy(theIntersectIterator.begin(), theIntersectIterator.end(), 
          ostream_iterator <const char*> (out, "\n"));

std::cout << "\ntest_debug.txt file is created\n";

}



